
import struct

class header(object) :
    """CDP Header : Ciholas Data Protocol Header Class Definition"""

    size = 20

    def __init__(self, data=[]) :

        #Initialize Containers to reasonable values. This isn't necessary, but makes code readable.
        self.mark     = 0x3230434c  # 4-byte pre-defined packet marker
        self.sequence = 0           # 4-byte unsigned integer sequence number
        self.string   = "CDP0002\0"   # 8-byte ASCII string identifier
        self.uid      = 0           # 4-byte unsigned integer reporting node serial number

        if data :
            self.decode(data)
            self.callback()

    def decode(self, data) :

        _mark,\
        self.sequence,\
        _string,\
        self.uid =      struct.unpack("<II8sI", data)

        if _mark != self.mark  :
            raise ValueError("CDP Header Un-recognized Mark : 0x%04X"%_mark)
        if _string != self.string :
            raise ValueError("CDP Header Un-Recognized String : %s"%_string)

    def callback(self) : pass

    def output(self) :

        print "%010d "   % self.sequence + \
              "0x%08X :" % self.uid
