import struct


class anchor_status:
    """CDP Data Type : Ciholas Data Protocol Anchor Status Data Type
    Definition"""
    type_value = 0x0103

    def __init__(self, data=[]):
        # Initialize containers to reasonable values. This isn't necessary,
        #   but makes code readable
        self.anchor_serial_number = 0
        self.status = 0

        if data:
            self.decode(data)
            self.callback()

    def decode(self, data):
        self.anchor_serial_number, \
            self.status = struct.unpack("<IB", data)

    def callback(self) : pass

    def output(self) :
        print "\tanc st" + \
              " 0x%08X" % self.anchor_serial_number + \
              " %02x"   % self.status
