import struct

class distance :
    """CDP Data Type : Ciholas Data Protocol Distance Data Type Definition"""
    type_value = 0x0101
    size = 26

    def __init__(self, data=[]) :
        #Initialize containers to reasonable values. This isn't necessary, but makes code readable
        self.partner_sn = 0     # 4-byte serial number of the other device in the TWR transaction
        self.rnge = 0          # 4-byte distance value in milllimeters
        self.first_path = 0.0   # 4-byte first path signal quality in dB (signed float)
        self.total_path = 0.0   # 4-byte total path signal quality in dB (signed float)
        self.sequence  = 0      # 2-byte sequence number sent from device
        self.gnt = 0            # 4-byte Global Network Time

        if data:
            self.decode(data)
            self.callback()

    def decode(self, data) :

        self.partner_sn,    \
        self.rnge,          \
        self.first_path,    \
        self.total_path,    \
        self.sequence,      \
        self.gnt = struct.unpack("<IiffHI", data)

    def callback(self) : pass

    def output(self) :
        print "\tdist   " + \
              " %08X," % self.partner_sn + \
              " %d,"   % self.rnge + \
              " %f,"   % self.first_path + \
              " %f,"   % self.total_path + \
              " %d,"   % self.sequence + \
              " %d"    % self.gnt

