import struct


class infrastructure:
    """CDP Data Type : Ciholas Data Protocol Infrastructure Data Type
    Definition"""
    type_value = 0x0102

    def __init__(self, data=[]):
        # Initialize containers to reasonable values. This isn't necessary,
        #   but makes code readable
        self.node_type = 0
        self.serial_number = 0
        self.x = 0
        self.y = 0
        self.z = 0

        if data:
            self.decode(data)
            self.callback()

    def decode(self, data):
        self.node_type, \
            self.serial_number, \
            self.x, \
            self.y, \
            self.z = struct.unpack("<BIiii", data)

    def callback(self) : pass

    def output(self) :
        print "\tinfra " + \
              " %d,"     % self.node_type + \
              " 0x%08x," % self.serial_number + \
              " %d,"     % self.x + \
              " %d,"     % self.y + \
              " %d,"     % self.z
