import struct

class lps_pressure :
    """CDP Data Type : Ciholas Data Protocol Pressure Data Type Definition"""
    type_value = 0x0005
    size = 8

    def __init__(self, data=[]) :
        #Initialize containers to reasonable values. This isn't necessary, but makes code readable
        self.pressure = 0 # 4-byte raw pressure value from LPS25H
        self.gnt = 0      # 4-byte Global Network Time

        if data : 
            self.decode(data)
            self.callback()

    def decode(self, data) :
        self.pressure, \
        self.gnt = struct.unpack("<II", data)

    def callback(self) : pass

    def output(self) :
        print "\tpress  " + \
              " %d," % self.pressure + \
              " %d"  % self.gnt


