import struct

class lps_temperature :
    """CDP Data Type : Ciholas Data Protocol Temperature Data Type Definition"""
    type_value = 0x0006
    size = 6

    def __init__(self, data=[]) :
        #Initialize containers to reasonable values. This isn't necessary, but makes code readable
        self.temperature = 0 # 2-byte raw LPS25H temperature value
        self.gnt = 0         # 4-byte Global Network Time

        if data : 
            self.decode(data)
            self.callback()

    def decode(self, data) :
        self.temperature, \
        self.gnd = struct.unpack("<HI", data)

    def callback(self) : pass

    def output(self) :
        print "\ttemp   " + \
              " %d," % self.temperature + \
              " %d"  % self.gnt

