import struct

class mpu_gyro :
    """CDP Data Type : Ciholas Data Protocol Gyro Data Type Definition"""
    type_value = 0x0009
    size = 13

    def __init__(self, data=[]) :
        #Initialize containers to reasonable values. This isn't necessary, but makes code readable
        self.xyz   = [] # 3-element array containing 2-byte raw gyro values
        self.gnt   = 0  # 4-byte Global Network Time
        self.scale = 0  # 2-byte value indication full scale value in degrees/s
        self.dlpf  = 0  # 1-byte value indication Digital Low-Pass Filter setting

        if data :
            self.decode(data)
            self.callback()

    def decode(self, data) :
        _x,_y,_z,   \
        self.gnt,   \
        self.scale, \
        self.dlpf   = struct.unpack("<hhhIHB", data)
        self.xyz.extend( (_x,_y,_z) )

    def callback(self) : pass

    def output(self) :
        print "\tgyro   " + \
              " %d," % self.xyz[0] + \
              " %d," % self.xyz[1] + \
              " %d"  % self.xyz[2] + \
              " %d"  % self.scale + \
              " %d"  % self.dlpf + \
              " %d"  % self.gnt

