import struct

class mpu_gyro_v1 :
    """CDP Data Type : Ciholas Data Protocol Gyro Data Type Definition"""
    type_value = 0x0002
    size = 10

    def __init__(self, data=[]) :
        #Initialize containers to reasonable values. This isn't necessary, but makes code readable
        self.xyz = [] # 3-element array containing 2-byte raw gyro values
        self.gnt = 0  # 4-byte Global Network Time

        if data :
            self.decode(data)
            self.callback()

    def decode(self, data) :
        _x,_y,_z,      \
        self.gnt = struct.unpack("<hhhI", data)
        self.xyz.extend( (_x,_y,_z) )

    def callback(self) : pass

    def output(self) :
        print "\tgyro   " + \
              " %d," % self.xyz[0] + \
              " %d," % self.xyz[1] + \
              " %d," % self.xyz[2] + \
              " %d"  % self.gnt

