import struct

class mpu_quaternion : 
    """CDP Data Type : Ciholas Data Protocol Quaternion Data Type Definition"""
    type_value = 0x000A
    size = 20

    def __init__(self, data=[]) :
        #Initialize containers to reasonable values. This isn't necessary, but makes code readable
        self.wxyz = [0.0, 0.0, 0.0, 0.0] # 4-element array containing 4-byte raw quaternion values
        self.gnt = 0

        if data : 
            self.decode(data)
            self.callback()

    def decode(self, data) :
        _x,_y,_z,_w, \
        self.gnt = struct.unpack("<iiiiI", data)
        self.wxyz[0] = (_x * 1.0) / (1<<30)
        self.wxyz[1] = (_y * 1.0) / (1<<30)
        self.wxyz[2] = (_z * 1.0) / (1<<30)
        self.wxyz[3] = (_w * 1.0) / (1<<30)

    def callback(self) : pass

    def output(self) : 
        print "\tquat   " + \
              " %0.3f," % self.wxyz[0] + \
              " %0.3f," % self.wxyz[1] + \
              " %0.3f," % self.wxyz[2] + \
              " %0.3f"  % self.wxyz[3] + \
              " %d"     % self.gnt
              
