import struct

class position :
    """CDP Data Type : Ciholas Data Protocol Position Data Type Definition"""
    type_value = 0x0100
    size = 24

    def __init__(self, data=[]) :
        #Initialize containers to reasonable values. This isn't necessary, but makes code readable
        self.xyz = []      # 3-element array containing XYZ 4-byte values in millimeters
        self.quality   = 0 # 4-byte quality indicator
        self.smoothing = 0 # 2-byte effective smoothing factor
        self.sequence  = 0 # 2-byte sequence number sent from device
        self.gnt       = 0 # 4-byte Global Network Time

        if data : 
            self.decode(data)
            self.callback()

    def decode(self, data) :

        _x,_y,_z,       \
        self.quality,   \
        self.smoothing, \
        self.sequence,  \
        self.gnt  = struct.unpack("<iiiIHHI", data)
        self.xyz.extend( (_x, _y, _z) )

    def callback(self) : pass

    def output(self) :
        print "\tpos    " + \
              " %0.3f," % (self.xyz[0] / 1000.0) + \
              " %0.3f," % (self.xyz[1] / 1000.0) + \
              " %0.3f"  % (self.xyz[2] / 1000.0) + \
              " %d"    % self.quality + \
              " %d"    % self.smoothing + \
              " %d"    % self.sequence + \
              " %d"    % self.gnt
